<?php
namespace HCM\BTL\Repository;

use Doctrine\ORM\EntityManager;

class FinalizarProcessoRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    
    public function getAltebancohoras($params){
    $query = $this->entityManager->getConnection()->prepare("
            SELECT *
                FROM PTO_ALTEBANCOHORAS
                WHERE NRORG = :P_NRORG
                AND NRVINCULOM = :P_NRVINCULOM
                "
        );
        $query->execute($params);
        return $query->fetchAll();
        
    }
    
    public function getProgocorrencia($params){
    $query = $this->entityManager->getConnection()->prepare("
            SELECT *
                FROM PTO_PROGOCORRENCIA
                WHERE NRORG = :P_NRORG
                AND NRVINCULOM = :P_NRVINCULOM
                "
        );
        $query->execute($params);
        return $query->fetchAll();
        
    }
    
    public function deleteAltebancohoras($params){
    $query = $this->entityManager->getConnection()->prepare("
            DELETE
                FROM PTO_ALTEBANCOHORAS
                WHERE NRORG = :P_NRORG
                AND NRALTEBANCOHORAS = :P_NRALTEBANCOHORAS
                "
        );
        $query->execute($params);
    }
    
    public function deleteProgocorrencia($params){
    $query = $this->entityManager->getConnection()->prepare("
            DELETE
                FROM PTO_PROGOCORRENCIA
                WHERE NRORG = :P_NRORG
                AND NRPROGOCORRENCIA = :P_NRPROGOCORRENCIA
                "
        );
        $query->execute($params);
    }
    
     public function getParticipaprocesso($params){
    $query = $this->entityManager->getConnection()->prepare("
            SELECT *
                FROM DES_PARTICIPAPROCESSO
                WHERE NRPROCESSO = :P_NRPROCESSO
                AND NRORG = :P_NRORG
                AND NRPARCNEGOCIOCAND = :P_NRPARCNEGOCIOCAND
                "
        );

        $query->execute($params);
        return $query->fetchAll();
        
    }
    
    public function updateParticipaprocesso($params){
        try {
            $query = $this->entityManager->getConnection()->prepare("
                    UPDATE DES_PARTICIPAPROCESSO
                        SET NRVINCULOM = :P_NRVINCULOM
                            WHERE NRPROCESSO = :P_NRPROCESSO
                                AND NRPARCNEGOCIOCAND = :P_NRPARCNEGOCIOCAND
                                AND NRORG = :P_NRORG"
                );

            $query->execute($params);;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function updateNovoCodigo($nrorg) {
        $query = $this->entityManager->getConnection()->prepare("
            UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRPARCNEGOCIO) + 1,'20','0') FROM PARCNEGOCIO WHERE NRORG = :NRORG) WHERE NRORG = :NRORG AND CDCONTADOR = 'PARCNEGOCIO'
        ");

         $query->execute(
            array(
                "NRORG"      => $nrorg
            )
        );

        $query = $this->entityManager->getConnection()->prepare("
            UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRPESSOA) + 1,'20','0') FROM GPE_PESSOA WHERE NRORG = :NRORG) WHERE NRORG = :NRORG AND CDCONTADOR = 'GPE_PESSOA'    
        ");

        $query->execute(
            array(
                "NRORG"      => $nrorg
            )
        );

        $query = $this->entityManager->getConnection()->prepare("
            UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRPESSOAH) + 1,'20','0') FROM GPE_PESSOAH WHERE NRORG = :NRORG) WHERE NRORG = :NRORG AND CDCONTADOR ='GPE_PESSOAH'     
        ");

        $query->execute(
            array(
                "NRORG"      => $nrorg
            )
        );

        $query = $this->entityManager->getConnection()->prepare("
            UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRCONTCORRPARC) + 1,'20','0') FROM CONTCORRPARC WHERE NRORG = :NRORG) WHERE NRORG = :NRORG AND CDCONTADOR = 'CONTCORRPARC'        
        ");

        $query->execute(
            array(
                "NRORG"      => $nrorg
            )
        );

        $query = $this->entityManager->getConnection()->prepare("
            UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRPARCERIA) + 1,'20','0') FROM PARCERIA WHERE NRORG = :NRORG) WHERE NRORG = :NRORG AND CDCONTADOR = 'PARCERIA'           
        ");

        $query->execute(
            array(
                "NRORG"      => $nrorg
            )
        );

        $query = $this->entityManager->getConnection()->prepare("
            UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRRELACIONAPARC) + 1,'20','0') FROM RELACIONAPARC WHERE NRORG = :NRORG) WHERE NRORG = :NRORG AND CDCONTADOR= 'RELACIONAPARC'
        ");

        $query->execute(
            array(
                "NRORG"      => $nrorg
            )
        );

        $query = $this->entityManager->getConnection()->prepare("
            UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRDEPVINCULO) + 1,'20','0') FROM FPA_DEPVINCULO WHERE NRORG = :NRORG) WHERE NRORG = :NRORG AND CDCONTADOR ='FPA_DEPVINCULO'
        ");

        $query->execute(
            array(
                "NRORG"      => $nrorg
            )
        );

        $query = $this->entityManager->getConnection()->prepare("
            UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRALTEOCUPACAO) + 1,'20','0') FROM GPE_ALTEOCUPACAO WHERE NRORG = :NRORG) WHERE NRORG = :NRORG AND CDCONTADOR = 'GPE_ALTEOCUPACAO'
        ");

        $query->execute(
            array(
                "NRORG"      => $nrorg
            )
        );

        $query = $this->entityManager->getConnection()->prepare("
            UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRALTEESCALA) + 1,'20','0') FROM GPE_ALTEESCALA WHERE NRORG = :NRORG) WHERE NRORG = :NRORG AND CDCONTADOR ='GPE_ALTEESCALA'
        ");

        $query->execute(
            array(
                "NRORG"      => $nrorg
            )
        );

        $query = $this->entityManager->getConnection()->prepare("
            UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRALTESITUFUNC) + 1,'20','0') FROM GPE_ALTESITUFUNC WHERE NRORG = :NRORG) WHERE NRORG = :NRORG AND CDCONTADOR = 'GPE_ALTESITUFUNC'
        ");

        $query->execute(
            array(
                "NRORG"      => $nrorg
            )
        );

        $query = $this->entityManager->getConnection()->prepare("
            UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRALTESALARIO) + 1,'20','0') FROM GPE_ALTESALARIO WHERE NRORG = :NRORG) WHERE NRORG = :NRORG AND CDCONTADOR ='GPE_ALTESALARIO'
        ");

        $query->execute(
            array(
                "NRORG"      => $nrorg
            )
        );

        $query = $this->entityManager->getConnection()->prepare("
            UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRMOVIMENTACAO) + 1,'20','0') FROM GPE_MOVIMENTACAO WHERE NRORG = :NRORG) WHERE NRORG = :NRORG AND CDCONTADOR = 'GPE_MOVIMENTACAO'
        ");

        $query->execute(
            array(
                "NRORG"      => $nrorg
            )
        );
    }

} 

