<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Geral\Entity\GpeGrauinstrEntity;
use HCM\Util\TkDI;
use HCM\Util\DateUtil;
use HCM\Util\MsgCalculo;
use HCM\Geral\Entity\GpepessoahEntity;
use HCM\FPA\Entity\FpadepvinculoEntity;
use HCM\FPA\Entity\FpatipodependeEntity;

class Dependencia {

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;

    private $_pessoa;
    private $_grauInstrucao;
    private $_dependencia;
    private $_tipoDependencia;

    public function __construct($entityManager, $hcmParameters){

        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        
        $this->_nrOrg = $hcmParameters->getNrorgTrabalho();
        $this->_nrOrgPadrao = $hcmParameters->getNrorgPadrao();
        $this->_mesCompetencia = $hcmParameters->getDtCompetencia();

        $this->_pessoa = TkDI::getContainer()->pessoa;
        $this->_dependencia = TkDI::getContainer()->dependencia;
        $this->_tipoDependencia = TkDI::getContainer()->tipo_dependencia;
        
        $this->_grauInstrucao = new GpeGrauinstrEntity($entityManager, $hcmParameters);
    }

    public function analisaDependencia($vinculo){
        $this->_dependencia->carregaDependenciasPorVinculo($vinculo->getNrvinculom());
        $dependencias = $this->_dependencia->getItems();
        
        $vinculo->historico->atualizaNrDependentesImpostoRenda(0);
        $vinculo->historico->atualizaNrDependentesSalarioFamilia(0);
            
        foreach($dependencias as $key => $dependencia){
            
            $nrDependentes= 0;
            $tipoDependencia = $this->_tipoDependencia->retornaTipoDependencia(
                $this->_nrOrg, $this->_nrOrgPadrao, $dependencia->getNrtipodepende()
            );
            
            if($dependencia->getIdexcdepende() != 'S') {
                
                $pessoa = $this->_pessoa->retornaPessoaAtual($dependencia->getNrpessoa());
                
                $dtComp = DateUtil::getDataDeString($this->_mesCompetencia, DateUtil::FORMATO_BRASILEIRO, true);
                
			    if ($pessoa->historico) {
					if(!$pessoa->historico->getDtnascpessoa()){
						MsgCalculo::getInstance()->adicionaMensagem('Sem data de nascimento para a pessoa: '.$pessoa->historico->getNrpessoa().'-'.$pessoa->historico->getNmpessoa());
						continue;
					}
					
                    $dataNascDependente = DateUtil::getDataDeString(substr($pessoa->historico->getDtnascpessoa(), 0, 10) , DateUtil::FORMATO_BRASILEIRO, true);
                    
					$sexoDependente = $pessoa->historico->getIdsexopessoa();
					
                    $idadeDependente = DateUtil::getQtdeAnosEntre($dataNascDependente, $dtComp);
					
					if(!$pessoa->historico->getIdsexopessoa()&& ($tipoDependencia->getNrtipodepende()==2)) {
						MsgCalculo::getInstance()->adicionaMensagem('Sem sexo cadastrado para a pessoa: '.$pessoa->historico->getNrpessoa().'-'.$pessoa->historico->getNmpessoa());
						continue;
					}
				}	
                switch ($sexoDependente) {
                    case GpepessoahEntity::IDSEXOPESSOA_MASCULINO:
                    if ($idadeDependente < $tipoDependencia->getNridadelimhonun()) {
                        $nrDependentes++;
                    } else {
                        if ($dependencia->getIduniversitario() == FpadepvinculoEntity::IDUNIVERSITARIO_SIM){
                            if ($idadeDependente <= $tipoDependencia->getNridadelimhouni()) {
                                $nrDependentes++;
                            }
                        }
                    }
                    break;
                    case GpepessoahEntity::IDSEXOPESSOA_FEMININO:
                    if ($idadeDependente < $tipoDependencia->getNridadelimmunun()) {
                        $nrDependentes++;
                    } else {
                        if ($dependencia->getIduniversitario() == FpadepvinculoEntity::IDUNIVERSITARIO_SIM){
                            if ($idadeDependente <= $tipoDependencia->getNridadelimmuuni()) {
                                $nrDependentes++;
                            }
                        }
                    }
                    break;
                }

            }else if ($dependencia->getIddependeconta() == 'S') {
               $nrDependentes++;
            }
            if ($nrDependentes > 0){
                $this->_atualizaDependentesVinculo($vinculo, $tipoDependencia, $nrDependentes);			
            }
        }
    }

    private function _atualizaDependentesVinculo(
     $vinculo, $tipoDependencia, $nrDependentes
    ) {
        
        if ($tipoDependencia->getIdatudepsalfam() === FpatipodependeEntity::IDATUDEPSALFAM_SIM) {
            $nrDependentes += $vinculo->historico->getNrdependsfam();
            $vinculo->historico->atualizaNrDependentesSalarioFamilia($nrDependentes);
            $this->entityManager->persist($vinculo->historico);
        }
        if ($tipoDependencia->getIdatudepirrf() === FpatipodependeEntity::IDATUDEPIRRF_SIM) {
            $nrDependentes += $vinculo->historico->getNrdependir();
            $vinculo->historico->atualizaNrDependentesImpostoRenda($nrDependentes);
            $this->entityManager->persist($vinculo->historico);
        }
    }
}