<?php

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;

class ParametroSindicatoService {
    protected $entityManager;
    protected $hcmParameters;
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
   public function replicaParametroSindicato($row, $nrestruturam, &$nmestruturam) {
        $sindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findBy(
            array('nrorg' => $row['NRORG'], 'nrestruturam' =>$nrestruturam));
        $estrutura = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->findBy(
        array('nrorg' => $row['NRORG'], 'nrestruturam' =>$nrestruturam));
        $nmestruturam=$estrutura[0]->getNmestruturam();
        if (count($sindicato)==0){
            $novaEstrutura['NRORG'] = $row['NRORG'];
            $novaEstrutura['NRESTRUTURAM'] = $nrestruturam;
            $novaEstrutura['IDATIVO'] = $row['IDATIVO'];
            $novaEstrutura['DTINICIOVIGENCIA'] = DateUtil::getDataDeString($row['DTINICIOVIGENCIA']);
            $novaEstrutura['DTFIMVIGENCIA'] = DateUtil::getDataDeString($row['DTFIMVIGENCIA']);
            $novaEstrutura['IDULTRANOANT13'] = $row['IDULTRANOANT13'];
            $novaEstrutura['IDULTRPERANTFER'] = $row['IDULTRPERANTFER'];
            $novaEstrutura['NRMESESMEDIA1'] = $row['NRMESESMEDIA1'];
            $novaEstrutura['NRMESESMEDIA2'] = $row['NRMESESMEDIA2'];
            $novaEstrutura['NRMESESMEDIA3'] = $row['NRMESESMEDIA3'];
            $novaEstrutura['CDSINDICAL'] = $row['CDSINDICAL'];
            $novaEstrutura['DTBASESINDICAL'] = DateUtil::getDataDeString($row['DTBASESINDICAL']);
            $novaEstrutura['NRDIV13ANTECIP'] = $row['NRDIV13ANTECIP'];
            $novaEstrutura['NRDIASAPURVALES'] = $row['NRDIASAPURVALES'];
            $novaEstrutura['VRPERDESCVALE'] = $row['VRPERDESCVALE'];
            $novaEstrutura['NRSINDICATO'] = $row['NRSINDICATO'] = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgPadrao(), 'FPA_PARAMSINDICATO', 1, 12, true);
            $nrnovaEstrutura = $this->setParametroSindicatoPorArray($novaEstrutura);
            return true;            
        }
        return false;
   }
   
   public function setParametroSindicatoPorArray($row){
        $fpa_paramsidicato = Repositories::FPA_PARAMSINDICATO;
        $parametroSindicato = new $fpa_paramsidicato;
        $parametroSindicato->setNrestruturam($row['NRESTRUTURAM']);
        $parametroSindicato->setNrorg($row['NRORG']);
        $parametroSindicato->setNrsindicato(!empty($row['NRSINDICATO']) ? $row['NRSINDICATO'] : \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgPadrao(), 'FPA_PARAMSINDICATO', 1, 12, true));
        $parametroSindicato->setIdativo($row['IDATIVO']);
        $parametroSindicato->setIdultrperantfer($row['IDULTRPERANTFER']);
        $parametroSindicato->setDtiniciovigencia($row['DTINICIOVIGENCIA']);
        $parametroSindicato->setDtfimvigencia($row['DTFIMVIGENCIA']);
        $parametroSindicato->setIdultranoant13($row['IDULTRANOANT13']);
        $parametroSindicato->setNrmesesmedia1($row['NRMESESMEDIA1']);
        $parametroSindicato->setNrmesesmedia2($row['NRMESESMEDIA2']);
        $parametroSindicato->setNrmesesmedia3($row['NRMESESMEDIA3']);
        $parametroSindicato->setCdsindical($row['CDSINDICAL']);
        $parametroSindicato->setDtbasesindical($row['DTBASESINDICAL']);
        $parametroSindicato->setNrdiv13antecip($row['NRDIV13ANTECIP']);
        $parametroSindicato->setNrdiasapurvales($row['NRDIASAPURVALES']);
        $parametroSindicato->setVrperdescvale($row['VRPERDESCVALE']);
        $this->entityManager->persist($parametroSindicato);
        $this->entityManager->flush(); 
    }
    
}