<?php
namespace Geral\Entities;

/**
 * @method \Geral\Entities\Parcnegocio findOneByNrparcnegocioAndNrorg($nrparcnegocio, $nrorg)     static
 * @method \Geral\Entities\Parcnegocio findOneByNrinscricaoparcAndNrorg($nrinscricaoparc, $nrorg) static
 */

class Parcnegocio extends Base\Parcnegocio
{
    const IDATIVO_SIM   = "S";
    const IDPESSOAFISICA_NAO = "N";
    const IDPESSOAFISICA_SIM = "S";
    const IDINSTITUICAO_NAO = "N";
    const IDINSTITUICAO_SIM = "S";
    const CDTIPOPARCPRINCIPAL_PESSOA = "PESSOA";

    public function __construct(){
        $this->idativo = 'S';
        $this->dtinclusao = new \DateTime();
        $this->cdtipoinscricao = 'LIVRE';
        $this->dtinclusao = new \DateTime();
        $this->idpessoafisica = 'N';
        $this->idinstituicao = 'N';
    }

    // LISTA DE MÉTODOS UTILIZADOS EXCLUISIVAMENTE NA MIGRACAO ALINUTRI.
    /**
     * Retorna o codigo do Parcnegocio associado a uma estrutura, caso esta ja exista. Se não houver, este mesmo
     * Método deverá retornar um novo codigo para um novo parceiro.
     */
    public static function geraNovoCodigoMigracaoEstrutura($nrestrutura, $nrorg)
    {
        $estruturam   = \Geral\Repositories\Estruturam::getEstrutura($nrestrutura, $nrorg);
        $nrparcnegocio = $estruturam["NRPARCNEGOCIO"];
        if (!$nrparcnegocio) {
            $nrparcnegocio = \Geral\Util\NovoCodigo::geraNovoCodigoMigracao('PARCNEGOCIO', 'NRPARCNEGOCIO', $nrorg);
        }

        return $nrparcnegocio;
    }

    public static function geraNovoCodigoMigracaoVinculo($nrpessoa, $nrorg)
    {
        $pessoa = \Folha\Entities\GpePessoa::findOneByNrpessoaAndNrorg($nrpessoa, $nrorg);
        if ($pessoa instanceof \Folha\Entities\GpePessoa) {
            $nrparcnegocio = $pessoa->getNrparcnegocio();
        } else {
            $nrparcnegocio = \Geral\Util\NovoCodigo::geraCodigo($nrorg, 'INTG_PARCNEGOCIO_NRPARCNEGOCIO');
        }

        return $nrparcnegocio;
    }

    public static function geraNovoCodigoMigracaoDependente($nome, $dtnascimento, $nrorg)
    {

        $pessoa = \Folha\Entities\GpePessoah::getObjectByWhere(
            "nmpessoa = ? and (Dtnascpessoa = ? or Dtnascpessoa is null) and nrorg = ?", 
            array($nome, $dtnascimento, $nrorg)
        );

        if ($pessoa instanceof \Folha\Entities\GpePessoah) {
            $nrparcnegocio = $pessoa->getPessoa()->getNrparcnegocio();
        } else {
            $nrparcnegocio = \Geral\Util\NovoCodigo::geraCodigo($nrorg, 'INTG_PARCNEGOCIO_NRPARCNEGOCIO');
        }

        return $nrparcnegocio;
    }

}