/* Esta funo realiza o clculo do nvel de qualidade do projeto para cada dia de monitoramento
@C:\Web_409\Sql\End_Conv\Oracle\9120_GEPFUNO_HORAS_NIVELQUALIDADE.SQL
*/

CREATE OR REPLACE FUNCTION HORAS_NIVELQUALIDADE
   (P_CDFILIAL   IN ITEMPRODUTO.CDFILIAL%TYPE,
    P_CDPROJETO  IN SOLISERV.NRSOLISERV%TYPE,
    P_DATAFIM    IN NOTAFISCAL.DTENTRSAID%TYPE) RETURN NUMBER
AS
   V_DATAINI     NOTAFISCAL.DTENTRSAID%TYPE;
   V_VRTEMPOERR  ITEMPROIMPOS.VRBASECALCIT%TYPE;
   V_VRTEMPOIMP  ITEMPROIMPOS.VRBASECALCIT%TYPE;
BEGIN
    SELECT MAX(DTMONITOPROJ)
    INTO V_DATAINI
    FROM MONITORAPROJ
    WHERE CDFILIAL = P_CDFILIAL AND
          CDPROJETO = P_CDPROJETO AND
          DTMONITOPROJ < P_DATAFIM;

    IF V_DATAINI IS NULL THEN
       BEGIN
          SELECT DTINIPLANPRJ
          INTO V_DATAINI
          FROM PROJETO
          WHERE CDFILIAL = P_CDFILIAL AND
                CDPROJETO = P_CDPROJETO;
       EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
       END;
    END IF;

    /* Tempo apropriado com atividade de erro*/
    SELECT SUM(DTFAPATIVTAR - DTIAPATIVTAR)
    INTO V_VRTEMPOERR
    FROM SOLIBASELINE S, TAREFA T, PLANATIVTARE P, APROATIVTARE A
    WHERE S.CDFILIAL = P_CDFILIAL         AND
          S.CDPROJETO = P_CDPROJETO       AND
          S.CDFILIAL = T.CDFILIAL         AND
          S.NRSOLISERV = T.NRSOLISERV     AND
          T.CDFILIAL = P.CDFILIAL         AND
          T.NRTAREFA = P.NRTAREFA         AND
          (P.CDPROCESSO = '0000010196'    OR
           P.CDPROCESSO = '0000010706'    OR
           P.CDPROCESSO = '0000010712')   AND
          P.CDFILIAL = A.CDFILIAL         AND
          P.NRTAREFA = A.NRTAREFA         AND
          P.NRPLATIVTARE = A.NRPLATIVTARE AND
          TRUNC(A.DTFAPATIVTAR) BETWEEN V_DATAINI AND P_DATAFIM;

    /* Tempo apropriado com atividade de implementao */      
    SELECT SUM(DTFAPATIVTAR - DTIAPATIVTAR)
    INTO V_VRTEMPOIMP
    FROM SOLIBASELINE S, TAREFA T, PLANATIVTARE P, APROATIVTARE A
    WHERE S.CDFILIAL = P_CDFILIAL         AND
          S.CDPROJETO = P_CDPROJETO       AND
          S.CDFILIAL = T.CDFILIAL         AND
          S.NRSOLISERV = T.NRSOLISERV     AND
          T.CDFILIAL = P.CDFILIAL         AND
          T.NRTAREFA = P.NRTAREFA         AND
          (P.CDPROCESSO <> '0000010196'   AND
           P.CDPROCESSO <> '0000010706'   AND
           P.CDPROCESSO <> '0000010712')  AND
          P.CDFILIAL = A.CDFILIAL         AND
          P.NRTAREFA = A.NRTAREFA         AND
          P.NRPLATIVTARE = A.NRPLATIVTARE AND
          TRUNC(A.DTFAPATIVTAR) BETWEEN V_DATAINI AND P_DATAFIM;

    IF V_VRTEMPOIMP = 0 THEN
       RETURN(0);
    ELSE
       RETURN((V_VRTEMPOERR/V_VRTEMPOIMP)*100);
    END IF;
END;
/
